# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.AddTimespan
import SEAScope.API.Command

import SEAScope.types.timespan


def serialize(builder, span_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _timespan = SEAScope.types.timespan.serialize(builder, span_obj)

    cls = SEAScope.API.AddTimespan
    cls.AddTimespanStart(builder)
    cls.AddTimespanAddTimespan(builder, _timespan)
    cmd_args = cls.AddTimespanEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().addTimespan
    args_type = SEAScope.API.CommandArgs.CommandArgs().AddTimespan
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
