# -*- coding: utf-8 -*-

"""
@author <sylvain.herledan@oceandatalab.com>
@date: 2016-10-20
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.GetExtractionResponse
import SEAScope.API.Command
import SEAScope.types.extraction


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().getExtraction
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.GetExtractionResponse.GetExtractionResponse
    res = cls.GetRootAsGetExtractionResponse(buf, 0)

    extractions_count = res.ExtractionsLength()
    result = []
    for i in range(0, extractions_count):
        extraction = SEAScope.types.extraction.deserialize(res.Extractions(i))
        result.append(extraction)
    return result
