# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-15
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.GetRendering
import SEAScope.API.GetRenderingResponse
import SEAScope.API.Command
import SEAScope.types.renderable_id
import SEAScope.types.rendering_cfg


def serialize(builder, rid):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _rid = SEAScope.types.renderable_id.serialize(builder, rid)

    cls = SEAScope.API.GetRendering
    cls.GetRenderingStart(builder)
    cls.GetRenderingAddTarget(builder, _rid)
    cmd_args = cls.GetRenderingEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().getRendering
    args_type = SEAScope.API.CommandArgs.CommandArgs().GetRendering
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.GetRenderingResponse.GetRenderingResponse
    res = cls.GetRootAsGetRenderingResponse(buf, 0)

    rcfg = SEAScope.types.rendering_cfg.deserialize(res.Cfg())

    return rcfg
