# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.GetTimestepResponse
import SEAScope.API.Command
import SEAScope.types.timestep


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().getTimestep
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.GetTimestepResponse.GetTimestepResponse
    res = cls.GetRootAsGetTimestepResponse(buf, 0)

    timestep = SEAScope.types.timestep.deserialize(res.Timestep())

    return timestep
