# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-06
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.ListCollectionsResponse
import SEAScope.API.Command
import SEAScope.types.collection


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().listCollections
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.ListCollectionsResponse.ListCollectionsResponse
    res = cls.GetRootAsListCollectionsResponse(buf, 0)
    collections_count = res.CollectionsLength()
    result = []
    for i in range(0, collections_count):
        col_obj = SEAScope.types.collection.deserialize(res.Collections(i))
        result.append(col_obj)

    return result
