# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.ListTimespansResponse
import SEAScope.API.Command

import SEAScope.types.timespan


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().listTimespans
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.ListTimespansResponse.ListTimespansResponse
    res = cls.GetRootAsListTimespansResponse(buf, 0)
    timespans_count = res.TimespansLength()
    result = []
    for i in range(0, timespans_count):
        t = SEAScope.types.timespan.deserialize(res.Timespans(i))
        result.append(t)
    return result
