# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.ListVisibleDataResponse
import SEAScope.API.Command
import SEAScope.types.renderable_id


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().listVisibleData
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    deserializer = SEAScope.types.renderable_id.deserialize
    cls = SEAScope.API.ListVisibleDataResponse.ListVisibleDataResponse
    res = cls.GetRootAsListVisibleDataResponse(buf, 0)

    l = res.IdsLength()
    return {res.Uris(x): deserializer(res.Ids(x)) for x in range(0, l)}
