# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2017-05-15
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.LookAt
import SEAScope.API.Command


def serialize(builder, lon, lat):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.LookAt
    cls.LookAtStart(builder)
    cls.LookAtAddLon(builder, lon)
    cls.LookAtAddLat(builder, lat)
    cmd_args = cls.LookAtEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().lookAt
    args_type = SEAScope.API.CommandArgs.CommandArgs().LookAt
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
