# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-15
"""

import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.SetRendering
import SEAScope.API.Command


def serialize(builder, rcfg):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _rcfg = SEAScope.types.rendering_cfg.serialize(builder, rcfg)

    cls = SEAScope.API.SetRendering
    cls.SetRenderingStart(builder)
    cls.SetRenderingAddCfg(builder, _rcfg)
    cmd_args = cls.SetRenderingEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().setRendering
    args_type = SEAScope.API.CommandArgs.CommandArgs().SetRendering
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
