# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-11-02
"""

import flatbuffers
import SEAScope.API.DataBucket
import SEAScope.types.data_info


def serialize(builder, bucket_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, info = SEAScope.types.data_info.serialize(builder, bucket_obj['info'])

    cls = SEAScope.API.DataBucket

    l = len(bucket_obj['buffer'])
    cls.DataBucketStartBufferVector(builder, l)
    # Inefficient!
    # TODO: optimize this later, using internal methods of flatbuffers
    for value in bucket_obj['buffer'][::-1]:
        builder.PrependUint8(value)
    data_buffer = builder.EndVector(l)

    cls.DataBucketStart(builder)
    cls.DataBucketAddInfo(builder, info)
    cls.DataBucketAddBuffer(builder, data_buffer)
    bucket = cls.DataBucketEnd(builder)

    return builder, bucket


def deserialize(o):
    """"""
    pass
