# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-11-03
"""

import flatbuffers
import SEAScope.API.GranuleData
import SEAScope.types.data_bucket


def serialize(builder, data_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.GranuleData

    _fields = []
    for field in data_obj.keys():
        _field = builder.CreateString(field)
        _fields.append(_field)
    l = len(_fields)
    cls.GranuleDataStartFieldsVector(builder, l)
    for _field in _fields:
        builder.PrependUOffsetTRelative(_field)
    fields = builder.EndVector(l)

    _data = []
    for field in data_obj.keys():
        _, _d = SEAScope.types.data_bucket.serialize(builder, data_obj[field])
        _data.append(_d)
    cls.GranuleDataStartBucketsVector(builder, l)
    for _d in _data:
        builder.PrependUOffsetTRelative(_d)
    buckets = builder.EndVector(l)

    cls.GranuleDataStart(builder)
    cls.GranuleDataAddFields(builder, fields)
    cls.GranuleDataAddBuckets(builder, buckets)
    g_data = cls.GranuleDataEnd(builder)

    return builder, g_data


def deserialize(o):
    """"""
    pass
